Panda3D

Loading...
Searching...
No Matches
Classes | Macros | Functions
notifyCategoryProxy.h File Reference

PANDA 3D SOFTWARE Copyright (c) Carnegie Mellon University. More...

`#include "dtoolbase.h"`
`#include "notifyCategory.h"`
`#include "notifySeverity.h"`
`#include "pnotify.h"`
`#include "notifyCategoryProxy.I"`

Go to the source code of this file.

## Classes
class | NotifyCategoryProxy< GetCategory >
| A handy wrapper around a NotifyCategory pointer. More...

## Macros
#define | NotifyCategoryDecl(basename, expcl, exptp)
#define | NotifyCategoryDeclNoExport(basename)
#define | NotifyCategoryDef(basename, parent_category)
#define | NotifyCategoryDefName(basename, actual_name, parent_category)

## Functions
template<class GetCategory>
std::ostream & | operator<< (std::ostream &out, NotifyCategoryProxy< GetCategory > &proxy)

## Detailed Description

PANDA 3D SOFTWARE Copyright (c) Carnegie Mellon University.

All rights reserved.

All use of this software is subject to the terms of the revised BSD license. You should have received a copy of this license along with this source code in a file named "LICENSE."

Author
  drose

Date
  2000-03-04

Definition in file notifyCategoryProxy.h.

## Macro Definition Documentation

## ◆ NotifyCategoryDecl

#define NotifyCategoryDecl | ( |  | basename,
|  |  | expcl,
|  |  | exptp )

Value:
class expcl NotifyCategoryGetCategory_ ## basename { \
public: \
NotifyCategoryGetCategory_ ## basename(); \
static NotifyCategory *get_category(); \
}; \
EXPORT_TEMPLATE_CLASS(expcl, exptp, NotifyCategoryProxy<NotifyCategoryGetCategory_ ## basename>); \
extern expcl NotifyCategoryProxy<NotifyCategoryGetCategory_ ## basename> basename ## _cat;
NotifyCategoryProxy
A handy wrapper around a NotifyCategory pointer.
Definition notifyCategoryProxy.h:51
NotifyCategory
A particular category of error messages.
Definition notifyCategory.h:32

Definition at line 115 of file notifyCategoryProxy.h.

## ◆ NotifyCategoryDeclNoExport

#define NotifyCategoryDeclNoExport | ( |  | basename | ) |

Value:
class NotifyCategoryGetCategory_ ## basename { \
public: \
NotifyCategoryGetCategory_ ## basename(); \
static NotifyCategory *get_category(); \
}; \
extern NotifyCategoryProxy<NotifyCategoryGetCategory_ ## basename> basename ## _cat;

Definition at line 128 of file notifyCategoryProxy.h.

## ◆ NotifyCategoryDef

#define NotifyCategoryDef | ( |  | basename,
|  |  | parent_category )

Value:
NotifyCategoryDefName(basename, #basename, parent_category);

Definition at line 159 of file notifyCategoryProxy.h.

## ◆ NotifyCategoryDefName

#define NotifyCategoryDefName | ( |  | basename,
|  |  | actual_name,
|  |  | parent_category )

Value:
template class NotifyCategoryProxy<NotifyCategoryGetCategory_ ## basename>; \
NotifyCategoryProxy<NotifyCategoryGetCategory_ ## basename> basename ## _cat; \
static NotifyCategoryGetCategory_ ## basename force_init_ ## basename ## _cat; \
NotifyCategoryGetCategory_ ## basename:: \
NotifyCategoryGetCategory_ ## basename() { \
basename ## _cat.init(); \
} \
NotifyCategory *NotifyCategoryGetCategory_ ## basename:: \
get_category() { \
return Notify::ptr()->get_category(std::string(actual_name), parent_category); \
}
NotifyCategoryProxy::init
NotifyCategory * init()
Initializes the proxy object by calling get_category() on the template class.
Definition notifyCategoryProxy.I:20
Notify::get_category
NotifyCategory * get_category(const std::string &basename, NotifyCategory *parent_category)
Finds or creates a new Category given the basename of the category and its parent in the category hie...
Definition notify.cxx:183
Notify::ptr
static Notify * ptr()
Returns the pointer to the global Notify object.
Definition notify.cxx:293

Definition at line 147 of file notifyCategoryProxy.h.

## Function Documentation

## ◆ operator<<()

template<class GetCategory>

std::ostream & operator<< | ( | std::ostream & | out,
|  | NotifyCategoryProxy< GetCategory > & | proxy )
| inline

Definition at line 101 of file notifyCategoryProxy.h.